#lang racket
(require (for-syntax syntax/parse
                     racket/list)
         "method-macro.rkt"
         "class-macro.rkt")

(provide this arg class new get set send ssend if0
         (rename-out [module-begin #%module-begin]
                     [datum #%datum]
                     [+-form +]
                     [*-form *]))

(define-syntax-rule (+-form l r) (+ l r))
(define-syntax-rule (*-form l r) (* l r))
(define-syntax-rule (if0 c l r) (if (= c 0) l r))

(define-syntax (module-begin stx)
  (syntax-parse stx
    #:literals (class)
    [(module-begin {class _ ...} ... expr)
     (syntax-parse #'expr
       #:literals (class)
       [{class _ ...}
        (raise-syntax-error 
         'module-begin
         "need an expression after classes")]
       [_
        (datum->syntax
         #'here
         (cons #'#%module-begin
               (rest (syntax-e stx))))])]))

(define-syntax (datum stx)
  (syntax-parse stx
    [(datum . v:number) #'(#%datum . v)]
    [(datum . other) (raise-syntax-error #f "bad syntax" #'other)]))
