#lang racket
(require racket/stxparam)
(provide method this arg)

(define-syntax-parameter this-name #f)
(define-syntax-parameter arg-name #f)

(define-for-syntax (make-param-use form-name param-name)
  (lambda (stx) 
    (define v (syntax-parameter-value param-name))
    (if v
        v
        (raise-syntax-error form-name
                            "illegal outside of method"
                            stx))))

(define-syntax this (make-param-use 'this #'this-name))
(define-syntax arg (make-param-use 'arg #'arg-name))

(define-syntax-rule (method expr)
  (lambda (this-n arg-n)
    (syntax-parameterize ([this-name #'this-n]
                          [arg-name #'arg-n])
      expr)))

(module+ test
  (require rackunit)
  (check-equal? ((method (+ this arg))
                 1
                 2)
                3))

(define-syntax-rule (method-plus expr)
  (method (+ 1 expr)))

(module+ test
  (check-equal? ((method-plus (+ this arg))
                 1
                 2)
                4))

